'use strict';
var callExpressionA = require('nodes');
var nodes = callExpressionA.nodes, syntax = callExpressionA.syntax;
var callExpression = require('../util/id');
var createUniqueDeclaration = callExpression.createUniqueDeclaration;
exports.default = function arrowify(program) {
  var q = [
      '#ArrowFunctionExpression => #ThisExpression',
      '#ArrowFunctionExpression => #Identifier:reference[name=arguments]'
    ];
  program.search(q).forEach(function (expression) {
    var arrowFunction = expression.scope();
    var arrowScope = arrowFunction.scope('[type!=ArrowFunctionExpression]');
    var id;
    if (expression.type === syntax.ThisExpression) {
      id = createUniqueDeclaration(arrowScope, 'self', 'this');
    } else {
      id = createUniqueDeclaration(arrowScope, 'parameters', 'arguments');
    }
    expression.parentNode.replaceChild(expression, id);
  });
  program.search('#ArrowFunctionExpression').forEach(function (node) {
    var shallow = new nodes.FunctionExpression(node);
    node.parentNode.replaceChild(node, shallow);
  });
};