'use strict';
var callExpressionA = require('../util/id');
var createUniqueDeclaration = callExpressionA.createUniqueDeclaration;
var callExpression = require('../util/string');
var express = callExpression.express;
exports.default = function restify(program) {
  program.search('#Function[rest!=null]').forEach(function (node) {
    var block = node.body.body;
    var length = node.params.length;
    var sliceId = createUniqueDeclaration(program, 'slice', 'Array.prototype.slice');
    var declaration = express('var ' + node.rest.name + ' = ' + sliceId.name + '.call(arguments, ' + length + ')');
    node.rest = null;
    block.unshift(declaration);
  });
};