'use strict';
var callExpressionB = require('nodes');
var nodes = callExpressionB.nodes;
var callExpressionA = require('./string');
var express = callExpressionA.express;
var callExpression = require('./insertion');
var insertAfterStrict = callExpression.insertAfterStrict;
var letters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var letter = function (i) {
  if (i <= 25) {
    return letters[i];
  }
  return letter(Math.floor(i / 26) - 1) + letters[i % 26];
};
var getUniqueName = function (node, name) {
  var names = node.search('#Identifier:declaration > name, #Identifier:reference > name');
  var preferred = name, i = 0;
  while (~names.indexOf(name)) {
    name = preferred + letter(i++) + '';
  }
  return name;
};
exports.getUniqueName = getUniqueName;
var getUniqueId = function (node, name) {
  name = getUniqueName(node, name);
  return new nodes.Identifier({ name: name });
};
exports.getUniqueId = getUniqueId;
var createUniqueDeclaration = function (node, name, expression) {
  var id = '@@' + name;
  if (!node[id]) {
    var uniqueName = getUniqueName(node, name);
    var declaration = express('var ' + uniqueName + ' = ' + expression);
    insertAfterStrict(node, declaration);
    node[id] = declaration.declarations[0].id;
  }
  return node[id].clone();
};
exports.createUniqueDeclaration = createUniqueDeclaration;