'use strict';
var callExpression = require('nodes');
var nodes = callExpression.nodes, lists = callExpression.lists;
var List = lists.List;
var listIndex = function (node) {
  var lastNode = node, firstList;
  while (node = node.parentNode) {
    if (node instanceof List && node.parentNode.body === node) {
      firstList = node;
      break;
    } else {
      lastNode = node;
    }
  }
  if (!firstList) {
    throw new Error('parent list not found');
  }
  return {
    list: firstList,
    index: firstList.indexOf(lastNode)
  };
};
var insertBefore = function (node, node2) {
  var li = listIndex(node);
  li.list.splice(li.index, 0, node2);
  return node2;
};
exports.insertBefore = insertBefore;
var insertAfter = function (node, node2) {
  var li = listIndex(node);
  li.list.splice(li.index + 1, 0, node2);
  return node2;
};
exports.insertAfter = insertAfter;
var insertAfterStrict = function (parentNode, node) {
  var body = nodes.Function.test(parentNode) ? parentNode.body.body : parentNode.body;
  var firstChild = body[0];
  if (firstChild && firstChild.matches('#ExpressionStatement > expression#Literal[value=use strict] < *')) {
    body.splice(1, 0, node);
  } else {
    body.unshift(node);
  }
  return node;
};
exports.insertAfterStrict = insertAfterStrict;